// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package integration

// GENERATED BY go run ./tools/cmd/gen-types. DO NOT EDIT.

//lint:file-ignore S1001,S1002,S1008,SA4013 generated code

import (
	"bytes"
	"encoding/json"
	"errors"
	"fmt"
	"io"
	"strings"
	"time"

	"gitlab.com/accumulatenetwork/accumulate/pkg/types/encoding"
)

type Point struct {
	fieldsSet []bool
	MinerIdx  uint64 `json:"minerIdx,omitempty" form:"minerIdx" query:"minerIdx" validate:"required"`
	Points    uint64 `json:"points,omitempty" form:"points" query:"points" validate:"required"`
	extraData []byte
}

type PointsReport struct {
	fieldsSet  []bool
	BlockIndex uint64   `json:"blockIndex,omitempty" form:"blockIndex" query:"blockIndex" validate:"required"`
	Points     []*Point `json:"points,omitempty" form:"points" query:"points" validate:"required"`
	extraData  []byte
}

type Price struct {
	fieldsSet []bool
	extraData []byte
}

type Report struct {
	fieldsSet    []bool
	ValidatorIdx uint64       `json:"validatorIdx,omitempty" form:"validatorIdx" query:"validatorIdx" validate:"required"`
	Settings     Settings     `json:"settings,omitempty" form:"settings" query:"settings" validate:"required"`
	Submission   Submission   `json:"submission,omitempty" form:"submission" query:"submission" validate:"required"`
	PointsReport PointsReport `json:"pointsReport,omitempty" form:"pointsReport" query:"pointsReport" validate:"required"`
	Payouts      []TxOutput   `json:"payouts,omitempty" form:"payouts" query:"payouts" validate:"required"`
	extraData    []byte
}

type Settings struct {
	fieldsSet        []bool
	BlockHeight      uint64    `json:"blockHeight,omitempty" form:"blockHeight" query:"blockHeight" validate:"required"`
	ValidatorIndex   uint64    `json:"validatorIndex,omitempty" form:"validatorIndex" query:"validatorIndex" validate:"required"`
	TimeStamp        time.Time `json:"timeStamp,omitempty" form:"timeStamp" query:"timeStamp" validate:"required"`
	SubmissionHeight uint64    `json:"submissionHeight,omitempty" form:"submissionHeight" query:"submissionHeight" validate:"required"`
	WindowBlockIndex uint64    `json:"windowBlockIndex,omitempty" form:"windowBlockIndex" query:"windowBlockIndex" validate:"required"`
	DNIndex          uint64    `json:"dnindex,omitempty" form:"dnindex" query:"dnindex" validate:"required"`
	WindowTimestamp  time.Time `json:"windowTimestamp,omitempty" form:"windowTimestamp" query:"windowTimestamp" validate:"required"`
	DiffWindow       uint64    `json:"diffWindow,omitempty" form:"diffWindow" query:"diffWindow" validate:"required"`
	LastDiff         uint64    `json:"lastDiff,omitempty" form:"lastDiff" query:"lastDiff" validate:"required"`
	Loops            uint64    `json:"loops,omitempty" form:"loops" query:"loops" validate:"required"`
	Bits             uint64    `json:"bits,omitempty" form:"bits" query:"bits" validate:"required"`
	DNHash           [32]byte  `json:"dnhash,omitempty" form:"dnhash" query:"dnhash" validate:"required"`
	SubmissionCnt    uint64    `json:"submissionCnt,omitempty" form:"submissionCnt" query:"submissionCnt" validate:"required"`
	Difficulty       uint64    `json:"difficulty,omitempty" form:"difficulty" query:"difficulty" validate:"required"`
	BlockTime        uint64    `json:"blockTime,omitempty" form:"blockTime" query:"blockTime" validate:"required"`
	LastBlockTime    uint64    `json:"lastBlockTime,omitempty" form:"lastBlockTime" query:"lastBlockTime" validate:"required"`
	PayoutFreq       uint64    `json:"payoutFreq,omitempty" form:"payoutFreq" query:"payoutFreq" validate:"required"`
	Qualifies        uint64    `json:"qualifies,omitempty" form:"qualifies" query:"qualifies" validate:"required"`
	Budget           float64   `json:"budget,omitempty" form:"budget" query:"budget" validate:"required"`
	extraData        []byte
}

type Submission struct {
	fieldsSet  []bool
	Valid      bool      `json:"valid,omitempty" form:"valid" query:"valid" validate:"required"`
	TimeStamp  time.Time `json:"timeStamp,omitempty" form:"timeStamp" query:"timeStamp" validate:"required"`
	DNIndex    uint64    `json:"dnindex,omitempty" form:"dnindex" query:"dnindex" validate:"required"`
	DNHash     [32]byte  `json:"dnhash,omitempty" form:"dnhash" query:"dnhash" validate:"required"`
	BlockIndex uint64    `json:"blockIndex,omitempty" form:"blockIndex" query:"blockIndex" validate:"required"`
	Nonce      uint64    `json:"nonce,omitempty" form:"nonce" query:"nonce" validate:"required"`
	MinerIdx   uint64    `json:"minerIdx,omitempty" form:"minerIdx" query:"minerIdx" validate:"required"`
	PoW        uint64    `json:"poW,omitempty" form:"poW" query:"poW" validate:"required"`
	extraData  []byte
}

type TxOutput struct {
	fieldsSet  []bool
	MinerIndex uint64  `json:"minerIndex,omitempty" form:"minerIndex" query:"minerIndex" validate:"required"`
	Amount     float64 `json:"amount,omitempty" form:"amount" query:"amount" validate:"required"`
	extraData  []byte
}

type URLRegistry struct {
	fieldsSet []bool
	TokenURL  string `json:"tokenURL,omitempty" form:"tokenURL" query:"tokenURL" validate:"required"`
	extraData []byte
}

func (v *Point) Copy() *Point {
	u := new(Point)

	u.MinerIdx = v.MinerIdx
	u.Points = v.Points
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Point) CopyAsInterface() interface{} { return v.Copy() }

func (v *PointsReport) Copy() *PointsReport {
	u := new(PointsReport)

	u.BlockIndex = v.BlockIndex
	u.Points = make([]*Point, len(v.Points))
	for i, v := range v.Points {
		if v != nil {
			u.Points[i] = (v).Copy()
		}
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *PointsReport) CopyAsInterface() interface{} { return v.Copy() }

func (v *Price) Copy() *Price {
	u := new(Price)

	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Price) CopyAsInterface() interface{} { return v.Copy() }

func (v *Report) Copy() *Report {
	u := new(Report)

	u.ValidatorIdx = v.ValidatorIdx
	u.Settings = *(&v.Settings).Copy()
	u.Submission = *(&v.Submission).Copy()
	u.PointsReport = *(&v.PointsReport).Copy()
	u.Payouts = make([]TxOutput, len(v.Payouts))
	for i, v := range v.Payouts {
		u.Payouts[i] = *(&v).Copy()
	}
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Report) CopyAsInterface() interface{} { return v.Copy() }

func (v *Settings) Copy() *Settings {
	u := new(Settings)

	u.BlockHeight = v.BlockHeight
	u.ValidatorIndex = v.ValidatorIndex
	u.TimeStamp = v.TimeStamp
	u.SubmissionHeight = v.SubmissionHeight
	u.WindowBlockIndex = v.WindowBlockIndex
	u.DNIndex = v.DNIndex
	u.WindowTimestamp = v.WindowTimestamp
	u.DiffWindow = v.DiffWindow
	u.LastDiff = v.LastDiff
	u.Loops = v.Loops
	u.Bits = v.Bits
	u.DNHash = v.DNHash
	u.SubmissionCnt = v.SubmissionCnt
	u.Difficulty = v.Difficulty
	u.BlockTime = v.BlockTime
	u.LastBlockTime = v.LastBlockTime
	u.PayoutFreq = v.PayoutFreq
	u.Qualifies = v.Qualifies
	u.Budget = v.Budget
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Settings) CopyAsInterface() interface{} { return v.Copy() }

func (v *Submission) Copy() *Submission {
	u := new(Submission)

	u.Valid = v.Valid
	u.TimeStamp = v.TimeStamp
	u.DNIndex = v.DNIndex
	u.DNHash = v.DNHash
	u.BlockIndex = v.BlockIndex
	u.Nonce = v.Nonce
	u.MinerIdx = v.MinerIdx
	u.PoW = v.PoW
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *Submission) CopyAsInterface() interface{} { return v.Copy() }

func (v *TxOutput) Copy() *TxOutput {
	u := new(TxOutput)

	u.MinerIndex = v.MinerIndex
	u.Amount = v.Amount
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *TxOutput) CopyAsInterface() interface{} { return v.Copy() }

func (v *URLRegistry) Copy() *URLRegistry {
	u := new(URLRegistry)

	u.TokenURL = v.TokenURL
	if len(v.extraData) > 0 {
		u.extraData = make([]byte, len(v.extraData))
		copy(u.extraData, v.extraData)
	}

	return u
}

func (v *URLRegistry) CopyAsInterface() interface{} { return v.Copy() }

func (v *Point) Equal(u *Point) bool {
	if !(v.MinerIdx == u.MinerIdx) {
		return false
	}
	if !(v.Points == u.Points) {
		return false
	}

	return true
}

func (v *PointsReport) Equal(u *PointsReport) bool {
	if !(v.BlockIndex == u.BlockIndex) {
		return false
	}
	if len(v.Points) != len(u.Points) {
		return false
	}
	for i := range v.Points {
		if !((v.Points[i]).Equal(u.Points[i])) {
			return false
		}
	}

	return true
}

func (v *Price) Equal(u *Price) bool {

	return true
}

func (v *Report) Equal(u *Report) bool {
	if !(v.ValidatorIdx == u.ValidatorIdx) {
		return false
	}
	if !((&v.Settings).Equal(&u.Settings)) {
		return false
	}
	if !((&v.Submission).Equal(&u.Submission)) {
		return false
	}
	if !((&v.PointsReport).Equal(&u.PointsReport)) {
		return false
	}
	if len(v.Payouts) != len(u.Payouts) {
		return false
	}
	for i := range v.Payouts {
		if !((&v.Payouts[i]).Equal(&u.Payouts[i])) {
			return false
		}
	}

	return true
}

func (v *Settings) Equal(u *Settings) bool {
	if !(v.BlockHeight == u.BlockHeight) {
		return false
	}
	if !(v.ValidatorIndex == u.ValidatorIndex) {
		return false
	}
	if !((v.TimeStamp).Equal(u.TimeStamp)) {
		return false
	}
	if !(v.SubmissionHeight == u.SubmissionHeight) {
		return false
	}
	if !(v.WindowBlockIndex == u.WindowBlockIndex) {
		return false
	}
	if !(v.DNIndex == u.DNIndex) {
		return false
	}
	if !((v.WindowTimestamp).Equal(u.WindowTimestamp)) {
		return false
	}
	if !(v.DiffWindow == u.DiffWindow) {
		return false
	}
	if !(v.LastDiff == u.LastDiff) {
		return false
	}
	if !(v.Loops == u.Loops) {
		return false
	}
	if !(v.Bits == u.Bits) {
		return false
	}
	if !(v.DNHash == u.DNHash) {
		return false
	}
	if !(v.SubmissionCnt == u.SubmissionCnt) {
		return false
	}
	if !(v.Difficulty == u.Difficulty) {
		return false
	}
	if !(v.BlockTime == u.BlockTime) {
		return false
	}
	if !(v.LastBlockTime == u.LastBlockTime) {
		return false
	}
	if !(v.PayoutFreq == u.PayoutFreq) {
		return false
	}
	if !(v.Qualifies == u.Qualifies) {
		return false
	}
	if !(v.Budget == u.Budget) {
		return false
	}

	return true
}

func (v *Submission) Equal(u *Submission) bool {
	if !(v.Valid == u.Valid) {
		return false
	}
	if !((v.TimeStamp).Equal(u.TimeStamp)) {
		return false
	}
	if !(v.DNIndex == u.DNIndex) {
		return false
	}
	if !(v.DNHash == u.DNHash) {
		return false
	}
	if !(v.BlockIndex == u.BlockIndex) {
		return false
	}
	if !(v.Nonce == u.Nonce) {
		return false
	}
	if !(v.MinerIdx == u.MinerIdx) {
		return false
	}
	if !(v.PoW == u.PoW) {
		return false
	}

	return true
}

func (v *TxOutput) Equal(u *TxOutput) bool {
	if !(v.MinerIndex == u.MinerIndex) {
		return false
	}
	if !(v.Amount == u.Amount) {
		return false
	}

	return true
}

func (v *URLRegistry) Equal(u *URLRegistry) bool {
	if !(v.TokenURL == u.TokenURL) {
		return false
	}

	return true
}

var fieldNames_Point = []string{
	1: "MinerIdx",
	2: "Points",
}

func (v *Point) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.MinerIdx == 0) {
		writer.WriteUint(1, v.MinerIdx)
	}
	if !(v.Points == 0) {
		writer.WriteUint(2, v.Points)
	}

	_, _, err := writer.Reset(fieldNames_Point)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Point) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field MinerIdx is missing")
	} else if v.MinerIdx == 0 {
		errs = append(errs, "field MinerIdx is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Points is missing")
	} else if v.Points == 0 {
		errs = append(errs, "field Points is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_PointsReport = []string{
	1: "BlockIndex",
	2: "Points",
}

func (v *PointsReport) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.BlockIndex == 0) {
		writer.WriteUint(1, v.BlockIndex)
	}
	if !(len(v.Points) == 0) {
		for _, v := range v.Points {
			writer.WriteValue(2, v.MarshalBinary)
		}
	}

	_, _, err := writer.Reset(fieldNames_PointsReport)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *PointsReport) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field BlockIndex is missing")
	} else if v.BlockIndex == 0 {
		errs = append(errs, "field BlockIndex is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Points is missing")
	} else if len(v.Points) == 0 {
		errs = append(errs, "field Points is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Price = []string{}

func (v *Price) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	_, _, err := writer.Reset(fieldNames_Price)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Price) IsValid() error {
	var errs []string

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Report = []string{
	1: "ValidatorIdx",
	2: "Settings",
	3: "Submission",
	4: "PointsReport",
	5: "Payouts",
}

func (v *Report) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.ValidatorIdx == 0) {
		writer.WriteUint(1, v.ValidatorIdx)
	}
	if !((v.Settings).Equal(new(Settings))) {
		writer.WriteValue(2, v.Settings.MarshalBinary)
	}
	if !((v.Submission).Equal(new(Submission))) {
		writer.WriteValue(3, v.Submission.MarshalBinary)
	}
	if !((v.PointsReport).Equal(new(PointsReport))) {
		writer.WriteValue(4, v.PointsReport.MarshalBinary)
	}
	if !(len(v.Payouts) == 0) {
		for _, v := range v.Payouts {
			writer.WriteValue(5, v.MarshalBinary)
		}
	}

	_, _, err := writer.Reset(fieldNames_Report)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Report) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field ValidatorIdx is missing")
	} else if v.ValidatorIdx == 0 {
		errs = append(errs, "field ValidatorIdx is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Settings is missing")
	} else if (v.Settings).Equal(new(Settings)) {
		errs = append(errs, "field Settings is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field Submission is missing")
	} else if (v.Submission).Equal(new(Submission)) {
		errs = append(errs, "field Submission is not set")
	}
	if len(v.fieldsSet) > 3 && !v.fieldsSet[3] {
		errs = append(errs, "field PointsReport is missing")
	} else if (v.PointsReport).Equal(new(PointsReport)) {
		errs = append(errs, "field PointsReport is not set")
	}
	if len(v.fieldsSet) > 4 && !v.fieldsSet[4] {
		errs = append(errs, "field Payouts is missing")
	} else if len(v.Payouts) == 0 {
		errs = append(errs, "field Payouts is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Settings = []string{
	1:  "BlockHeight",
	2:  "ValidatorIndex",
	3:  "TimeStamp",
	4:  "SubmissionHeight",
	5:  "WindowBlockIndex",
	6:  "DNIndex",
	7:  "WindowTimestamp",
	8:  "DiffWindow",
	9:  "LastDiff",
	10: "Loops",
	11: "Bits",
	12: "DNHash",
	13: "SubmissionCnt",
	14: "Difficulty",
	15: "BlockTime",
	16: "LastBlockTime",
	17: "PayoutFreq",
	18: "Qualifies",
	19: "Budget",
}

func (v *Settings) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.BlockHeight == 0) {
		writer.WriteUint(1, v.BlockHeight)
	}
	if !(v.ValidatorIndex == 0) {
		writer.WriteUint(2, v.ValidatorIndex)
	}
	if !(v.TimeStamp == (time.Time{})) {
		writer.WriteTime(3, v.TimeStamp)
	}
	if !(v.SubmissionHeight == 0) {
		writer.WriteUint(4, v.SubmissionHeight)
	}
	if !(v.WindowBlockIndex == 0) {
		writer.WriteUint(5, v.WindowBlockIndex)
	}
	if !(v.DNIndex == 0) {
		writer.WriteUint(6, v.DNIndex)
	}
	if !(v.WindowTimestamp == (time.Time{})) {
		writer.WriteTime(7, v.WindowTimestamp)
	}
	if !(v.DiffWindow == 0) {
		writer.WriteUint(8, v.DiffWindow)
	}
	if !(v.LastDiff == 0) {
		writer.WriteUint(9, v.LastDiff)
	}
	if !(v.Loops == 0) {
		writer.WriteUint(10, v.Loops)
	}
	if !(v.Bits == 0) {
		writer.WriteUint(11, v.Bits)
	}
	if !(v.DNHash == ([32]byte{})) {
		writer.WriteHash(12, &v.DNHash)
	}
	if !(v.SubmissionCnt == 0) {
		writer.WriteUint(13, v.SubmissionCnt)
	}
	if !(v.Difficulty == 0) {
		writer.WriteUint(14, v.Difficulty)
	}
	if !(v.BlockTime == 0) {
		writer.WriteUint(15, v.BlockTime)
	}
	if !(v.LastBlockTime == 0) {
		writer.WriteUint(16, v.LastBlockTime)
	}
	if !(v.PayoutFreq == 0) {
		writer.WriteUint(17, v.PayoutFreq)
	}
	if !(v.Qualifies == 0) {
		writer.WriteUint(18, v.Qualifies)
	}
	if !(v.Budget == 0) {
		writer.WriteFloat(19, v.Budget)
	}

	_, _, err := writer.Reset(fieldNames_Settings)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Settings) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field BlockHeight is missing")
	} else if v.BlockHeight == 0 {
		errs = append(errs, "field BlockHeight is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field ValidatorIndex is missing")
	} else if v.ValidatorIndex == 0 {
		errs = append(errs, "field ValidatorIndex is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field TimeStamp is missing")
	} else if v.TimeStamp == (time.Time{}) {
		errs = append(errs, "field TimeStamp is not set")
	}
	if len(v.fieldsSet) > 3 && !v.fieldsSet[3] {
		errs = append(errs, "field SubmissionHeight is missing")
	} else if v.SubmissionHeight == 0 {
		errs = append(errs, "field SubmissionHeight is not set")
	}
	if len(v.fieldsSet) > 4 && !v.fieldsSet[4] {
		errs = append(errs, "field WindowBlockIndex is missing")
	} else if v.WindowBlockIndex == 0 {
		errs = append(errs, "field WindowBlockIndex is not set")
	}
	if len(v.fieldsSet) > 5 && !v.fieldsSet[5] {
		errs = append(errs, "field DNIndex is missing")
	} else if v.DNIndex == 0 {
		errs = append(errs, "field DNIndex is not set")
	}
	if len(v.fieldsSet) > 6 && !v.fieldsSet[6] {
		errs = append(errs, "field WindowTimestamp is missing")
	} else if v.WindowTimestamp == (time.Time{}) {
		errs = append(errs, "field WindowTimestamp is not set")
	}
	if len(v.fieldsSet) > 7 && !v.fieldsSet[7] {
		errs = append(errs, "field DiffWindow is missing")
	} else if v.DiffWindow == 0 {
		errs = append(errs, "field DiffWindow is not set")
	}
	if len(v.fieldsSet) > 8 && !v.fieldsSet[8] {
		errs = append(errs, "field LastDiff is missing")
	} else if v.LastDiff == 0 {
		errs = append(errs, "field LastDiff is not set")
	}
	if len(v.fieldsSet) > 9 && !v.fieldsSet[9] {
		errs = append(errs, "field Loops is missing")
	} else if v.Loops == 0 {
		errs = append(errs, "field Loops is not set")
	}
	if len(v.fieldsSet) > 10 && !v.fieldsSet[10] {
		errs = append(errs, "field Bits is missing")
	} else if v.Bits == 0 {
		errs = append(errs, "field Bits is not set")
	}
	if len(v.fieldsSet) > 11 && !v.fieldsSet[11] {
		errs = append(errs, "field DNHash is missing")
	} else if v.DNHash == ([32]byte{}) {
		errs = append(errs, "field DNHash is not set")
	}
	if len(v.fieldsSet) > 12 && !v.fieldsSet[12] {
		errs = append(errs, "field SubmissionCnt is missing")
	} else if v.SubmissionCnt == 0 {
		errs = append(errs, "field SubmissionCnt is not set")
	}
	if len(v.fieldsSet) > 13 && !v.fieldsSet[13] {
		errs = append(errs, "field Difficulty is missing")
	} else if v.Difficulty == 0 {
		errs = append(errs, "field Difficulty is not set")
	}
	if len(v.fieldsSet) > 14 && !v.fieldsSet[14] {
		errs = append(errs, "field BlockTime is missing")
	} else if v.BlockTime == 0 {
		errs = append(errs, "field BlockTime is not set")
	}
	if len(v.fieldsSet) > 15 && !v.fieldsSet[15] {
		errs = append(errs, "field LastBlockTime is missing")
	} else if v.LastBlockTime == 0 {
		errs = append(errs, "field LastBlockTime is not set")
	}
	if len(v.fieldsSet) > 16 && !v.fieldsSet[16] {
		errs = append(errs, "field PayoutFreq is missing")
	} else if v.PayoutFreq == 0 {
		errs = append(errs, "field PayoutFreq is not set")
	}
	if len(v.fieldsSet) > 17 && !v.fieldsSet[17] {
		errs = append(errs, "field Qualifies is missing")
	} else if v.Qualifies == 0 {
		errs = append(errs, "field Qualifies is not set")
	}
	if len(v.fieldsSet) > 18 && !v.fieldsSet[18] {
		errs = append(errs, "field Budget is missing")
	} else if v.Budget == 0 {
		errs = append(errs, "field Budget is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_Submission = []string{
	1: "Valid",
	2: "TimeStamp",
	3: "DNIndex",
	4: "DNHash",
	5: "BlockIndex",
	6: "Nonce",
	7: "MinerIdx",
	8: "PoW",
}

func (v *Submission) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(!v.Valid) {
		writer.WriteBool(1, v.Valid)
	}
	if !(v.TimeStamp == (time.Time{})) {
		writer.WriteTime(2, v.TimeStamp)
	}
	if !(v.DNIndex == 0) {
		writer.WriteUint(3, v.DNIndex)
	}
	if !(v.DNHash == ([32]byte{})) {
		writer.WriteHash(4, &v.DNHash)
	}
	if !(v.BlockIndex == 0) {
		writer.WriteUint(5, v.BlockIndex)
	}
	if !(v.Nonce == 0) {
		writer.WriteUint(6, v.Nonce)
	}
	if !(v.MinerIdx == 0) {
		writer.WriteUint(7, v.MinerIdx)
	}
	if !(v.PoW == 0) {
		writer.WriteUint(8, v.PoW)
	}

	_, _, err := writer.Reset(fieldNames_Submission)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *Submission) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field Valid is missing")
	} else if !v.Valid {
		errs = append(errs, "field Valid is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field TimeStamp is missing")
	} else if v.TimeStamp == (time.Time{}) {
		errs = append(errs, "field TimeStamp is not set")
	}
	if len(v.fieldsSet) > 2 && !v.fieldsSet[2] {
		errs = append(errs, "field DNIndex is missing")
	} else if v.DNIndex == 0 {
		errs = append(errs, "field DNIndex is not set")
	}
	if len(v.fieldsSet) > 3 && !v.fieldsSet[3] {
		errs = append(errs, "field DNHash is missing")
	} else if v.DNHash == ([32]byte{}) {
		errs = append(errs, "field DNHash is not set")
	}
	if len(v.fieldsSet) > 4 && !v.fieldsSet[4] {
		errs = append(errs, "field BlockIndex is missing")
	} else if v.BlockIndex == 0 {
		errs = append(errs, "field BlockIndex is not set")
	}
	if len(v.fieldsSet) > 5 && !v.fieldsSet[5] {
		errs = append(errs, "field Nonce is missing")
	} else if v.Nonce == 0 {
		errs = append(errs, "field Nonce is not set")
	}
	if len(v.fieldsSet) > 6 && !v.fieldsSet[6] {
		errs = append(errs, "field MinerIdx is missing")
	} else if v.MinerIdx == 0 {
		errs = append(errs, "field MinerIdx is not set")
	}
	if len(v.fieldsSet) > 7 && !v.fieldsSet[7] {
		errs = append(errs, "field PoW is missing")
	} else if v.PoW == 0 {
		errs = append(errs, "field PoW is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_TxOutput = []string{
	1: "MinerIndex",
	2: "Amount",
}

func (v *TxOutput) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(v.MinerIndex == 0) {
		writer.WriteUint(1, v.MinerIndex)
	}
	if !(v.Amount == 0) {
		writer.WriteFloat(2, v.Amount)
	}

	_, _, err := writer.Reset(fieldNames_TxOutput)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *TxOutput) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field MinerIndex is missing")
	} else if v.MinerIndex == 0 {
		errs = append(errs, "field MinerIndex is not set")
	}
	if len(v.fieldsSet) > 1 && !v.fieldsSet[1] {
		errs = append(errs, "field Amount is missing")
	} else if v.Amount == 0 {
		errs = append(errs, "field Amount is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

var fieldNames_URLRegistry = []string{
	1: "TokenURL",
}

func (v *URLRegistry) MarshalBinary() ([]byte, error) {
	if v == nil {
		return []byte{encoding.EmptyObject}, nil
	}

	buffer := new(bytes.Buffer)
	writer := encoding.NewWriter(buffer)

	if !(len(v.TokenURL) == 0) {
		writer.WriteString(1, v.TokenURL)
	}

	_, _, err := writer.Reset(fieldNames_URLRegistry)
	if err != nil {
		return nil, encoding.Error{E: err}
	}
	buffer.Write(v.extraData)
	return buffer.Bytes(), nil
}

func (v *URLRegistry) IsValid() error {
	var errs []string

	if len(v.fieldsSet) > 0 && !v.fieldsSet[0] {
		errs = append(errs, "field TokenURL is missing")
	} else if len(v.TokenURL) == 0 {
		errs = append(errs, "field TokenURL is not set")
	}

	switch len(errs) {
	case 0:
		return nil
	case 1:
		return errors.New(errs[0])
	default:
		return errors.New(strings.Join(errs, "; "))
	}
}

func (v *Point) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Point) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUint(1); ok {
		v.MinerIdx = x
	}
	if x, ok := reader.ReadUint(2); ok {
		v.Points = x
	}

	seen, err := reader.Reset(fieldNames_Point)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *PointsReport) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *PointsReport) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUint(1); ok {
		v.BlockIndex = x
	}
	for {
		if x := new(Point); reader.ReadValue(2, x.UnmarshalBinaryFrom) {
			v.Points = append(v.Points, x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_PointsReport)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Price) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Price) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	seen, err := reader.Reset(fieldNames_Price)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Report) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Report) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUint(1); ok {
		v.ValidatorIdx = x
	}
	if x := new(Settings); reader.ReadValue(2, x.UnmarshalBinaryFrom) {
		v.Settings = *x
	}
	if x := new(Submission); reader.ReadValue(3, x.UnmarshalBinaryFrom) {
		v.Submission = *x
	}
	if x := new(PointsReport); reader.ReadValue(4, x.UnmarshalBinaryFrom) {
		v.PointsReport = *x
	}
	for {
		if x := new(TxOutput); reader.ReadValue(5, x.UnmarshalBinaryFrom) {
			v.Payouts = append(v.Payouts, *x)
		} else {
			break
		}
	}

	seen, err := reader.Reset(fieldNames_Report)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Settings) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Settings) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUint(1); ok {
		v.BlockHeight = x
	}
	if x, ok := reader.ReadUint(2); ok {
		v.ValidatorIndex = x
	}
	if x, ok := reader.ReadTime(3); ok {
		v.TimeStamp = x
	}
	if x, ok := reader.ReadUint(4); ok {
		v.SubmissionHeight = x
	}
	if x, ok := reader.ReadUint(5); ok {
		v.WindowBlockIndex = x
	}
	if x, ok := reader.ReadUint(6); ok {
		v.DNIndex = x
	}
	if x, ok := reader.ReadTime(7); ok {
		v.WindowTimestamp = x
	}
	if x, ok := reader.ReadUint(8); ok {
		v.DiffWindow = x
	}
	if x, ok := reader.ReadUint(9); ok {
		v.LastDiff = x
	}
	if x, ok := reader.ReadUint(10); ok {
		v.Loops = x
	}
	if x, ok := reader.ReadUint(11); ok {
		v.Bits = x
	}
	if x, ok := reader.ReadHash(12); ok {
		v.DNHash = *x
	}
	if x, ok := reader.ReadUint(13); ok {
		v.SubmissionCnt = x
	}
	if x, ok := reader.ReadUint(14); ok {
		v.Difficulty = x
	}
	if x, ok := reader.ReadUint(15); ok {
		v.BlockTime = x
	}
	if x, ok := reader.ReadUint(16); ok {
		v.LastBlockTime = x
	}
	if x, ok := reader.ReadUint(17); ok {
		v.PayoutFreq = x
	}
	if x, ok := reader.ReadUint(18); ok {
		v.Qualifies = x
	}
	if x, ok := reader.ReadFloat(19); ok {
		v.Budget = x
	}

	seen, err := reader.Reset(fieldNames_Settings)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *Submission) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *Submission) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadBool(1); ok {
		v.Valid = x
	}
	if x, ok := reader.ReadTime(2); ok {
		v.TimeStamp = x
	}
	if x, ok := reader.ReadUint(3); ok {
		v.DNIndex = x
	}
	if x, ok := reader.ReadHash(4); ok {
		v.DNHash = *x
	}
	if x, ok := reader.ReadUint(5); ok {
		v.BlockIndex = x
	}
	if x, ok := reader.ReadUint(6); ok {
		v.Nonce = x
	}
	if x, ok := reader.ReadUint(7); ok {
		v.MinerIdx = x
	}
	if x, ok := reader.ReadUint(8); ok {
		v.PoW = x
	}

	seen, err := reader.Reset(fieldNames_Submission)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *TxOutput) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *TxOutput) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadUint(1); ok {
		v.MinerIndex = x
	}
	if x, ok := reader.ReadFloat(2); ok {
		v.Amount = x
	}

	seen, err := reader.Reset(fieldNames_TxOutput)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *URLRegistry) UnmarshalBinary(data []byte) error {
	return v.UnmarshalBinaryFrom(bytes.NewReader(data))
}

func (v *URLRegistry) UnmarshalBinaryFrom(rd io.Reader) error {
	reader := encoding.NewReader(rd)

	if x, ok := reader.ReadString(1); ok {
		v.TokenURL = x
	}

	seen, err := reader.Reset(fieldNames_URLRegistry)
	if err != nil {
		return encoding.Error{E: err}
	}
	v.fieldsSet = seen
	v.extraData, err = reader.ReadAll()
	if err != nil {
		return encoding.Error{E: err}
	}
	return nil
}

func (v *PointsReport) MarshalJSON() ([]byte, error) {
	u := struct {
		BlockIndex uint64                    `json:"blockIndex,omitempty"`
		Points     encoding.JsonList[*Point] `json:"points,omitempty"`
	}{}
	if !(v.BlockIndex == 0) {
		u.BlockIndex = v.BlockIndex
	}
	if !(len(v.Points) == 0) {
		u.Points = v.Points
	}
	return json.Marshal(&u)
}

func (v *Report) MarshalJSON() ([]byte, error) {
	u := struct {
		ValidatorIdx uint64                      `json:"validatorIdx,omitempty"`
		Settings     Settings                    `json:"settings,omitempty"`
		Submission   Submission                  `json:"submission,omitempty"`
		PointsReport PointsReport                `json:"pointsReport,omitempty"`
		Payouts      encoding.JsonList[TxOutput] `json:"payouts,omitempty"`
	}{}
	if !(v.ValidatorIdx == 0) {
		u.ValidatorIdx = v.ValidatorIdx
	}
	if !((v.Settings).Equal(new(Settings))) {
		u.Settings = v.Settings
	}
	if !((v.Submission).Equal(new(Submission))) {
		u.Submission = v.Submission
	}
	if !((v.PointsReport).Equal(new(PointsReport))) {
		u.PointsReport = v.PointsReport
	}
	if !(len(v.Payouts) == 0) {
		u.Payouts = v.Payouts
	}
	return json.Marshal(&u)
}

func (v *Settings) MarshalJSON() ([]byte, error) {
	u := struct {
		BlockHeight      uint64    `json:"blockHeight,omitempty"`
		ValidatorIndex   uint64    `json:"validatorIndex,omitempty"`
		TimeStamp        time.Time `json:"timeStamp,omitempty"`
		SubmissionHeight uint64    `json:"submissionHeight,omitempty"`
		WindowBlockIndex uint64    `json:"windowBlockIndex,omitempty"`
		DNIndex          uint64    `json:"dnindex,omitempty"`
		WindowTimestamp  time.Time `json:"windowTimestamp,omitempty"`
		DiffWindow       uint64    `json:"diffWindow,omitempty"`
		LastDiff         uint64    `json:"lastDiff,omitempty"`
		Loops            uint64    `json:"loops,omitempty"`
		Bits             uint64    `json:"bits,omitempty"`
		DNHash           string    `json:"dnhash,omitempty"`
		SubmissionCnt    uint64    `json:"submissionCnt,omitempty"`
		Difficulty       uint64    `json:"difficulty,omitempty"`
		BlockTime        uint64    `json:"blockTime,omitempty"`
		LastBlockTime    uint64    `json:"lastBlockTime,omitempty"`
		PayoutFreq       uint64    `json:"payoutFreq,omitempty"`
		Qualifies        uint64    `json:"qualifies,omitempty"`
		Budget           float64   `json:"budget,omitempty"`
	}{}
	if !(v.BlockHeight == 0) {
		u.BlockHeight = v.BlockHeight
	}
	if !(v.ValidatorIndex == 0) {
		u.ValidatorIndex = v.ValidatorIndex
	}
	if !(v.TimeStamp == (time.Time{})) {
		u.TimeStamp = v.TimeStamp
	}
	if !(v.SubmissionHeight == 0) {
		u.SubmissionHeight = v.SubmissionHeight
	}
	if !(v.WindowBlockIndex == 0) {
		u.WindowBlockIndex = v.WindowBlockIndex
	}
	if !(v.DNIndex == 0) {
		u.DNIndex = v.DNIndex
	}
	if !(v.WindowTimestamp == (time.Time{})) {
		u.WindowTimestamp = v.WindowTimestamp
	}
	if !(v.DiffWindow == 0) {
		u.DiffWindow = v.DiffWindow
	}
	if !(v.LastDiff == 0) {
		u.LastDiff = v.LastDiff
	}
	if !(v.Loops == 0) {
		u.Loops = v.Loops
	}
	if !(v.Bits == 0) {
		u.Bits = v.Bits
	}
	if !(v.DNHash == ([32]byte{})) {
		u.DNHash = encoding.ChainToJSON(v.DNHash)
	}
	if !(v.SubmissionCnt == 0) {
		u.SubmissionCnt = v.SubmissionCnt
	}
	if !(v.Difficulty == 0) {
		u.Difficulty = v.Difficulty
	}
	if !(v.BlockTime == 0) {
		u.BlockTime = v.BlockTime
	}
	if !(v.LastBlockTime == 0) {
		u.LastBlockTime = v.LastBlockTime
	}
	if !(v.PayoutFreq == 0) {
		u.PayoutFreq = v.PayoutFreq
	}
	if !(v.Qualifies == 0) {
		u.Qualifies = v.Qualifies
	}
	if !(v.Budget == 0) {
		u.Budget = v.Budget
	}
	return json.Marshal(&u)
}

func (v *Submission) MarshalJSON() ([]byte, error) {
	u := struct {
		Valid      bool      `json:"valid,omitempty"`
		TimeStamp  time.Time `json:"timeStamp,omitempty"`
		DNIndex    uint64    `json:"dnindex,omitempty"`
		DNHash     string    `json:"dnhash,omitempty"`
		BlockIndex uint64    `json:"blockIndex,omitempty"`
		Nonce      uint64    `json:"nonce,omitempty"`
		MinerIdx   uint64    `json:"minerIdx,omitempty"`
		PoW        uint64    `json:"poW,omitempty"`
	}{}
	if !(!v.Valid) {
		u.Valid = v.Valid
	}
	if !(v.TimeStamp == (time.Time{})) {
		u.TimeStamp = v.TimeStamp
	}
	if !(v.DNIndex == 0) {
		u.DNIndex = v.DNIndex
	}
	if !(v.DNHash == ([32]byte{})) {
		u.DNHash = encoding.ChainToJSON(v.DNHash)
	}
	if !(v.BlockIndex == 0) {
		u.BlockIndex = v.BlockIndex
	}
	if !(v.Nonce == 0) {
		u.Nonce = v.Nonce
	}
	if !(v.MinerIdx == 0) {
		u.MinerIdx = v.MinerIdx
	}
	if !(v.PoW == 0) {
		u.PoW = v.PoW
	}
	return json.Marshal(&u)
}

func (v *PointsReport) UnmarshalJSON(data []byte) error {
	u := struct {
		BlockIndex uint64                    `json:"blockIndex,omitempty"`
		Points     encoding.JsonList[*Point] `json:"points,omitempty"`
	}{}
	u.BlockIndex = v.BlockIndex
	u.Points = v.Points
	if err := json.Unmarshal(data, &u); err != nil {
		return err
	}
	v.BlockIndex = u.BlockIndex
	v.Points = u.Points
	return nil
}

func (v *Report) UnmarshalJSON(data []byte) error {
	u := struct {
		ValidatorIdx uint64                      `json:"validatorIdx,omitempty"`
		Settings     Settings                    `json:"settings,omitempty"`
		Submission   Submission                  `json:"submission,omitempty"`
		PointsReport PointsReport                `json:"pointsReport,omitempty"`
		Payouts      encoding.JsonList[TxOutput] `json:"payouts,omitempty"`
	}{}
	u.ValidatorIdx = v.ValidatorIdx
	u.Settings = v.Settings
	u.Submission = v.Submission
	u.PointsReport = v.PointsReport
	u.Payouts = v.Payouts
	if err := json.Unmarshal(data, &u); err != nil {
		return err
	}
	v.ValidatorIdx = u.ValidatorIdx
	v.Settings = u.Settings
	v.Submission = u.Submission
	v.PointsReport = u.PointsReport
	v.Payouts = u.Payouts
	return nil
}

func (v *Settings) UnmarshalJSON(data []byte) error {
	u := struct {
		BlockHeight      uint64    `json:"blockHeight,omitempty"`
		ValidatorIndex   uint64    `json:"validatorIndex,omitempty"`
		TimeStamp        time.Time `json:"timeStamp,omitempty"`
		SubmissionHeight uint64    `json:"submissionHeight,omitempty"`
		WindowBlockIndex uint64    `json:"windowBlockIndex,omitempty"`
		DNIndex          uint64    `json:"dnindex,omitempty"`
		WindowTimestamp  time.Time `json:"windowTimestamp,omitempty"`
		DiffWindow       uint64    `json:"diffWindow,omitempty"`
		LastDiff         uint64    `json:"lastDiff,omitempty"`
		Loops            uint64    `json:"loops,omitempty"`
		Bits             uint64    `json:"bits,omitempty"`
		DNHash           string    `json:"dnhash,omitempty"`
		SubmissionCnt    uint64    `json:"submissionCnt,omitempty"`
		Difficulty       uint64    `json:"difficulty,omitempty"`
		BlockTime        uint64    `json:"blockTime,omitempty"`
		LastBlockTime    uint64    `json:"lastBlockTime,omitempty"`
		PayoutFreq       uint64    `json:"payoutFreq,omitempty"`
		Qualifies        uint64    `json:"qualifies,omitempty"`
		Budget           float64   `json:"budget,omitempty"`
	}{}
	u.BlockHeight = v.BlockHeight
	u.ValidatorIndex = v.ValidatorIndex
	u.TimeStamp = v.TimeStamp
	u.SubmissionHeight = v.SubmissionHeight
	u.WindowBlockIndex = v.WindowBlockIndex
	u.DNIndex = v.DNIndex
	u.WindowTimestamp = v.WindowTimestamp
	u.DiffWindow = v.DiffWindow
	u.LastDiff = v.LastDiff
	u.Loops = v.Loops
	u.Bits = v.Bits
	u.DNHash = encoding.ChainToJSON(v.DNHash)
	u.SubmissionCnt = v.SubmissionCnt
	u.Difficulty = v.Difficulty
	u.BlockTime = v.BlockTime
	u.LastBlockTime = v.LastBlockTime
	u.PayoutFreq = v.PayoutFreq
	u.Qualifies = v.Qualifies
	u.Budget = v.Budget
	if err := json.Unmarshal(data, &u); err != nil {
		return err
	}
	v.BlockHeight = u.BlockHeight
	v.ValidatorIndex = u.ValidatorIndex
	v.TimeStamp = u.TimeStamp
	v.SubmissionHeight = u.SubmissionHeight
	v.WindowBlockIndex = u.WindowBlockIndex
	v.DNIndex = u.DNIndex
	v.WindowTimestamp = u.WindowTimestamp
	v.DiffWindow = u.DiffWindow
	v.LastDiff = u.LastDiff
	v.Loops = u.Loops
	v.Bits = u.Bits
	if x, err := encoding.ChainFromJSON(u.DNHash); err != nil {
		return fmt.Errorf("error decoding DNHash: %w", err)
	} else {
		v.DNHash = x
	}
	v.SubmissionCnt = u.SubmissionCnt
	v.Difficulty = u.Difficulty
	v.BlockTime = u.BlockTime
	v.LastBlockTime = u.LastBlockTime
	v.PayoutFreq = u.PayoutFreq
	v.Qualifies = u.Qualifies
	v.Budget = u.Budget
	return nil
}

func (v *Submission) UnmarshalJSON(data []byte) error {
	u := struct {
		Valid      bool      `json:"valid,omitempty"`
		TimeStamp  time.Time `json:"timeStamp,omitempty"`
		DNIndex    uint64    `json:"dnindex,omitempty"`
		DNHash     string    `json:"dnhash,omitempty"`
		BlockIndex uint64    `json:"blockIndex,omitempty"`
		Nonce      uint64    `json:"nonce,omitempty"`
		MinerIdx   uint64    `json:"minerIdx,omitempty"`
		PoW        uint64    `json:"poW,omitempty"`
	}{}
	u.Valid = v.Valid
	u.TimeStamp = v.TimeStamp
	u.DNIndex = v.DNIndex
	u.DNHash = encoding.ChainToJSON(v.DNHash)
	u.BlockIndex = v.BlockIndex
	u.Nonce = v.Nonce
	u.MinerIdx = v.MinerIdx
	u.PoW = v.PoW
	if err := json.Unmarshal(data, &u); err != nil {
		return err
	}
	v.Valid = u.Valid
	v.TimeStamp = u.TimeStamp
	v.DNIndex = u.DNIndex
	if x, err := encoding.ChainFromJSON(u.DNHash); err != nil {
		return fmt.Errorf("error decoding DNHash: %w", err)
	} else {
		v.DNHash = x
	}
	v.BlockIndex = u.BlockIndex
	v.Nonce = u.Nonce
	v.MinerIdx = u.MinerIdx
	v.PoW = u.PoW
	return nil
}
